fenceScreen = gideros.class(Sprite)

function fenceScreen:init()

---------------------------------------------------------------
-- DISPLAY SIZE VARIABLES
---------------------------------------------------------------
local _H= application:getLogicalWidth()
local _W= application:getLogicalHeight()
local centreX= _W/2
local centreY= _H/2


--------------------------------------------------------------
-- SOUND VARIABLES AND FUNCTIONS
---------------------------------------------------------------
local popSnd2= Sound.new("sounds/balloonBurst.wav")
local popSnd1= Sound.new("sounds/pop1.wav")
local popSnd3= Sound.new("sounds/pop3.wav")
local thudSnd= Sound.new("sounds/splatSnd.wav")
local clickSnd= Sound.new("sounds/click.wav")

---------------------------------------------------------------
-- FUNCTION VARIABLES
---------------------------------------------------------------
local trapNumber
local addSplats
local initialiseVars
local removeListeners
local startGame
--------------------------------------------------------------
-- VARIABLES
---------------------------------------------------------------
local level
local firstRun=true

local minNum
local maxNum

local picked=2
local oldPicked=2
local oldOldPicked=-1
local oldOldOldPicked=-1

local pickSameNumber=false
local pickedNumber

local total

local buttonsOn
local numberButtonsOn


local number={}
local splat={}

local exited

---------------------------------------------------------------
-- INITIAL SCENE DISPLAY OBJECTS
---------------------------------------------------------------
local bg=Bitmap.new(Texture.new("fenceAssets/bg.jpg",true))
self:addChild(bg)

local  bubble=Bitmap.new(Texture.new("fenceAssets/bubble.png",true))
bubble:setAnchorPoint(0.5,0.5)
self:addChild(bubble)

---------------------------------------------------------------
-- fence
---------------------------------------------------------------
local fence={}
local fenceSpacing=59
local fenceStartX=centreX-270
local fenceStartY=centreY+130
local fenceTexture=Texture.new("fenceAssets/plank.png",true)

for n=1,10 do
	fence[n]=Bitmap.new(fenceTexture)
	fence[n]:setAnchorPoint(0.5,1)
	fence[n]:setX(fenceStartX+(fenceSpacing*(n-1)))
	fence[n]:setY(fenceStartY)
	self:addChild(fence[n])
end

---------------------------------------------------------------
-- fence numbers
---------------------------------------------------------------
local label={}

local font = TTFont.new("ComickBook_Simple.ttf", 30) 
for n=1,10 do
	label[n]=TextField.new(font, "")
	label[n]:setTextColor(40,40,60)
	label[n]:setText(n)
	label[n]:setX(fenceStartX+(fenceSpacing*(n-1))-(label[n]:getWidth()/2)-2)
	label[n]:setY(fenceStartY-110)
	self:addChild(label[n])
end

----------------------
-- closebtn
----------------------
local closebtn =Bitmap.new(Texture.new("commonAssets/closebtn.png",true))
closebtn:setAnchorPoint(1,0)
closebtn:setX(_W-10)
closebtn:setY(10)
self:addChild(closebtn)


---------------------------------------------------------------
-- PICK NUMBER TO TRAP
---------------------------------------------------------------
-- math.randomseed(os.timer())
local maxNum=10
local minNum=3


local function rndPick()
    while picked==oldPicked or picked==oldOldPicked or picked==oldOldOldPicked do
      picked=math.random(maxNum-(minNum-1))+minNum-1
    end
  return  picked
end

local function setRandomNumber()
   if pickSameNumber==false then
     rndPick()
   end
   oldOldOldPicked=oldPicked
   oldOldPicked=oldPicked
   oldPicked=picked
end


---------------------------------------------------------------
-- SHOW NUMBERS
---------------------------------------------------------------
local nStartX=centreX-350
local nStartY=fenceStartY+50
local nSpacing=66
local nScale=0.6

local function showNumbers()
	for n=1,10 do
		number[n]=Bitmap.new(Texture.new("commonAssets/number"..(n)..".png",true))
		number[n]:setAnchorPoint(0.5,0.5)
		number[n]:setScaleX(nScale)
		number[n]:setScaleY(nScale)
		number[n]:setX(nStartX+(nSpacing*(n-1)))
		number[n]:setY(nStartY)
		if n==10 then
			number[n]:setX(number[n]:getX()+15)
		end
		self:addChild(number[n])
		number[n].number=n
		if n~=picked then
			number[n]:addEventListener(Event.MOUSE_DOWN,addSplats,number[n])
			number[n].clickable=true
		end
		self:removeChild(bubble)
		self:addChild(bubble)      
	end
	if not exited then
		trapNumber()
	end
end


---------------------------------------------------------------
-- TRAP number
---------------------------------------------------------------
local trapNumber2
local trapNumber3
local trapNumber4

trapNumber=function()
	numberButtonsOn=false
	buttonsOn=false
	bubble:setScaleX(0.01)
	bubble:setScaleY(0.01)
	bubble:setX(centreX)
	bubble:setY(80)
	bubble:setAlpha(1)
	bubbleChannel=popSnd1:play()
	GTween.new(bubble, 0.8, {y=bubble:getY()+30, scaleX=0.7, scaleY=0.7}, {onComplete=trapNumber2})
end

trapNumber2=function()
	GTween.new(bubble, 1, {x=number[picked]:getX(), y=number[picked]:getY(), scaleX=0.9, scaleY=0.9}, {onComplete=trapNumber3})
end

trapNumber3=function()
		bubbleChannel=popSnd3:play()
		bubbleTween3= GTween.new(bubble, 0.5, {x=fence[picked]:getX(), y=label[picked]:getY()-90, scaleX=0.7, scaleY=0.7}, {delay=0.3, onComplete=trapNumber4})
		GTween.new(number[picked], 0.5, {x=fence[picked]:getX(), y=label[picked]:getY()-90, scaleX=nScale-0.2, scaleY=nScale-0.2}, {delay=0.3, onComplete=trapNumber4})
--	end
end

trapNumber4=function()
	buttonsOn=true
	numberButtonsOn=true
end

---------------------------------------------------------
-- ADD SPLATS AND CHECK FOR WIN
---------------------------------------------------------

addSplats = function(self,e)
	if self:hitTestPoint(e.x, e.y) and numberButtonsOn and self.clickable then
		pickedNumber=self.number
		numberButtonsOn=false
		-- add splats to fence
		local splatTexture=Texture.new("fenceAssets/splat"..pickedNumber..".png",true)
		local splatFencePanel=0
		for n=1, pickedNumber do
			total=total+1
			splat[total]=Bitmap.new(splatTexture)
			splat[total]:setAnchorPoint(0.5,0.5)
			splat[total]:setX(nStartX+(nSpacing*(pickedNumber-1)))
			splat[total]:setY(nStartY)
			self:getParent():addChild(splat[total])  
			splat[total]:setX(fenceStartX+(fenceSpacing*(total-1)))
			splat[total]:setY(fenceStartY-70)
			if total>12 then
				splat[total]:setAlpha(0)
			end
		end

		if not exited then 
			blockChannel= thudSnd:play()
			if total<11 then
			--  UNCOMMENT THE NEXT LINE TO GET A MEMORY LEAK ********************
				--fence[total]:setScaleY(1.15)
			-- **********************************************************************
			
			end
			if total<picked then
				numberButtonsOn=true 
			end
		end 

		----------------------------
		-- check for win
		----------------------------
		if total==picked then
			numberButtonsOn=false
			won=true

			for n=picked+1,10 do
			--  UNCOMMENT THE NEXT LINE TO GET A MEMORY LEAK ********************
				--label[n]:setAlpha(0)
			-- **********************************************************************
			end
		end
			-- go to a pop bubble routine
	end

end


-----------------------------------
-- GOTO MENU SCREEN
-----------------------------------
gotoMenuScreen = function(self,e)
	if self:hitTestPoint(e.x, e.y) then
	
	e:stopPropagation()
		exited=true
		clickSnd:play()
		removeListeners()
		sceneManager:changeScene("mainMenu", 0.5, SceneManager.crossfade)	  
	end
end

---------------------------------------------------------------
-- SET INITIAL VALUES
---------------------------------------------------------------
initialiseVars = function()
	exited=false
	total=0
	buttonsOn=false
	bubble:setAlpha(0)
end

initialiseVars()

---------------------------------------------------------
-- START GAME
---------------------------------------------------------
startGame=function()
	setRandomNumber()
	showNumbers()
end

startGame()

-------------------------------------------------------------------
-- LISTENERS
-------------------------------------------------------------------
removeListeners=function()
	closebtn:removeEventListener(Event.MOUSE_DOWN,gotoMenuScreen,closebtn)
	for n=1, 10 do
		number[n]:removeEventListener(Event.MOUSE_DOWN,addSplats)
	end	
end


closebtn:addEventListener(Event.MOUSE_DOWN,gotoMenuScreen,closebtn)


end